/************************************************************************
* Copyright (c) 1995 Valentin Shopov, Blagoevgrad, Bulgaria		*
*									*
* Permission to use, copy, modify, and distribute this material for any	*
* purpose and without fee is hereby granted, provided that the above	*
* copyright notice and this permission notice appear in all copies, and	*
* that the name of the author not be used in advertising or publicity 	*
* pertaining to this material without the specific, prior written 	*
* permission of the author.						*
*									*
* THE AUTHOR MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY	*  
* OF THIS MATERIAL FOR ANY PURPOSE. IT IS PROVIDED "AS IS", WITHOUT ANY	* 
* EXPRESS OR IMPLIED WARRANTIES.					*
*************************************************************************/

/**************************ciilib1.2.0***********************************
 *									*
 *        Character to Inline Image Conversion Library (CIILIB)		*
 *									*
 *	Encoder for Character by Inline Image of HTML on HTTP		*
 *			by Valentin Shopov				*
 *			valentin@rs.aubg.bg				*
 ************************************************************************/

#include <stdio.h>
/*
int CII_isPRE;
*/
static int isTag, isTitle, isAnchor, is2inA, isIMG, isLAT, AncLen, isH1, TagBufLen;
static int isKOI;
static char *inHTMLcs=(char *) 0, AncBuf[2048], *Hchar="";
static unsigned char TagBuf[2048];

#if defined PLUS256C
extern char *chsetabbr[];
extern int numof256c;
extern char *xbmsrc_256[][257];
extern int xbmind_256[][257];
#else if
static char *chsetabbr[]={0};
static int numof256c=0;
static char *xbmsrc_256[1][257];
static int xbmind_256[1][257];
#endif

extern char *CharsetID(/* char *abbr */);

static int to256c(csname)
	char *csname;
{	char *charset;

	if( (charset = CharsetID(csname)) == NULL )
		return 0;
        return strncasecmp(charset,"ISO-8859-",9) == 0;
}
static int is256c(charsets)
	char *charsets;
{	int convnum,i;
	char *charset;

        if(numof256c && to256c(charsets) ){
        convnum=0;
        for(i=0;chsetabbr[i];i++){
		if( charset = CharsetID(chsetabbr[i]) )
                if( charset == CharsetID(charsets) ){
                        convnum=i;
                        break;
                }
        }
	}
        else convnum=-1;
        return(convnum);
}

static unsigned char koi8tocyr(kchar)
unsigned char kchar;
{
char *cyrch="\356\320\321\346\324\325\344\323\345\330\331\332\333\334\
\335\336\337\357\340\341\342\343\326\322\354\353\327\350\355\351\347\352";
if(kchar>=0xc0 && kchar<=0xdf) return cyrch[kchar-0xc0];
else if(kchar>=0xe0 && kchar<=0xff) return cyrch[kchar-0xe0]-32;
else return kchar;
}


static int expandH1(srcb)
unsigned char srcb;
{int expb=0,dmask=3,i;
unsigned char smask=1;
for(i=0;i<8;i++){
	expb|=(srcb&smask)?dmask:0;
	smask<<=1;
	dmask<<=2;
}
return expb;
}


static int strncscmp(str1,str2,snum)
char *str1, *str2;
int snum;
{char ch1;
int i,j,isSPC;
for(i=0,j=0,isSPC=0;i<snum && str1[j];i++){
for(;str1[j]<=' ' && str1[j];){
        j++;
        isSPC=1;
}
ch1=str1[j];
if(ch1>='a' && ch1<='z') ch1-=32;
if(isSPC){
        isSPC=0;
	if(ch1=='=' && str2[i]=='=') {
		j++;
		continue;
	}
	if(str2[i-1]=='='){
		i--;
		continue;
	}
        if(ch1=='>' && str2[i]=='>') {
                j++;
                continue;
        }

        if(str2[i]!=' ') return 1;
}
else{
        if(str2[i]!=ch1) return 1;
        j++;
}
}
return 0;
}

static int isN256C(src)
unsigned char *src;
{
register unsigned char *sp;
int is8bit=0;

for(sp=src;*sp;sp++){
	if(*sp>=0x80){
		is8bit++;
		if(*sp<0xa0)
		return 1;
	}
}
return (is8bit)? 0:-1;
}

static int rvrsBUF(src)
unsigned char *src;
{
register unsigned char *sp,*dp;
unsigned char *tmpb;
tmpb=strdup(src);
for(sp=strrchr(tmpb,0)-1,dp=src;*dp;sp--,dp++) 
*dp=*sp;
free(tmpb);
}

extern char *HTTP_getRequestField();
unsigned char *
EUC_TO_CII(src,dst,ctype,charsetC,ubase)
unsigned char *src, *dst;
char *ctype,*charsetC,*ubase;
{	register unsigned char *sp,*dp;
	char *charset,*charsetsII, *Achar, *ltPTR, *gtPTR;
	unsigned char t256c;
	char inHTMLCC[32];
	int isPlain,do256,cs256,AncLen,i,isMozilla,chW,chH;
	char UserAGENT[1024];

	HTTP_getRequestField("User-Agent",UserAGENT);
        if(strstr(UserAGENT,"Emacs-W3")){
                strcpy(dst,src);
                return dst;
        }

        if(strstr(UserAGENT,"Mozilla/1.1")) isMozilla=1;
	else isMozilla=0;

	isPlain = strcasecmp(ctype,"text/plain") == 0;

        charsetsII=(inHTMLcs)? inHTMLcs : charsetC;

        charset = (isKOI)? CharsetID("cyr") : CharsetID(charsetsII);
        if( charset == NULL ){
                strcpy(dst,src);
                return dst;
        }

        do256 = to256c(charset);
        cs256 = is256c(charset);

        ltPTR=(char *)strrchr(src,'<');
        gtPTR=(char *)strrchr(src,'>');

        if((gtPTR && ltPTR-gtPTR>0) ||  ((TagBufLen || ltPTR) && !gtPTR)){
		for(i=0;src[i];i++){
			TagBuf[TagBufLen++]=src[i];
		}
		TagBuf[TagBufLen]='\0';	
		*dst='\0';
		return dst;
	}
	
        if(TagBufLen){
                for(i=0;src[i];i++){
                        TagBuf[TagBufLen++]=src[i];
                }
                TagBuf[TagBufLen]='\0'; 
	} 
                       
 

	for(sp=(TagBufLen)?TagBuf:src, dp=dst; *sp; ){
/*
	if(CII_isPRE>0 && isPlain){
	sprintf(dp,"<PRE>");
	dp+=5;
	CII_isPRE=-1;
	}
*/	
	if(*sp == '<' && !isTag && !isPlain){
		
		isTag=1;
		if(!isH1 && !strncscmp(sp,"<H1>",4)){isH1=1;Hchar="h";}
		else
                if(isH1 && !strncscmp(sp,"</H1>",5)){isH1=0;Hchar="";}
		else
		if(!isAnchor && !strncscmp(sp,"<A ",3)){ 
		for(i=0;sp[i]!='>';i++) {
			if(!isAnchor && !strncscmp(sp+i," HREF=",6)){
			is2inA=isIMG=isLAT=0;
			isAnchor=1;
			}
			AncBuf[i]=sp[i];
			AncLen=i;
			}
			AncBuf[++AncLen]='>';
			AncBuf[++AncLen]='\0';
		}
		else
		if(isAnchor && !strncscmp(sp,"</A>",4)){
			isAnchor=0;
			isTag=0;
		if(is2inA<0 && !isLAT){
                        while(*sp!='>') sp++;
                        sp++;
                        continue;
                }
		}
		else
		if(!strncasecmp(sp,"<!CIICC=",8)){
			sscanf(sp+8,"%[^>]",inHTMLCC);	
			free((void *)inHTMLcs);
			if(!strncmp(inHTMLCC,"koi8",4)){
                        inHTMLcs=(char *)strdup("koi8");
			isKOI=1;
			}
			else
			inHTMLcs=(char *)strdup(CharsetID(inHTMLCC));

		        charsetsII=(inHTMLcs)? inHTMLcs : charsetC;

                        if(!strncmp(charsetsII,"koi8",4)){
                        charset = CharsetID("cyr");
                        do256 = to256c("cyr");
                        cs256 = is256c("cyr");
                        isKOI=1;
                        }
                        else{
                        isKOI=0;
                        charset = CharsetID(charsetsII);
                        do256 = to256c(charsetsII);
                        cs256 = is256c(charsetsII);
			}
		}
		else 
		if(!strncscmp(sp,"<!/CIICC>",9)){
			free((void *)inHTMLcs);
			inHTMLcs=(char *) 0;
                        if(!strncmp(charsetC,"koi8",4)){
                        charset = CharsetID("cyr");
                        do256 = to256c("cyr");
                        cs256 = is256c("cyr");
			isKOI=1;
			}
			else{
			isKOI=0;	
                        charset = CharsetID(charsetC);
                        do256 = to256c(charsetC);
 		        cs256 = is256c(charsetC);
			}

		}
		else
		if(!isTitle && !strncscmp(sp,"<TITLE>",7)) isTitle = 1;
		else
		if(isTitle && !strncscmp(sp,"</TITLE>",8)) isTitle = 0;
	}
	if(isTag || isTitle){
		if(*sp == '>' && isTag) isTag = 0;
		*dp++ = *sp++;
	}
	else{
		if( *sp & 0x80 ){
			if(isAnchor){
				isIMG=1;
				if(isLAT) is2inA=0;
				if(is2inA==0){
				is2inA=1;
				Achar="";
				}
				else
				if(is2inA>0){
					sprintf(dp,"</A>");
					dp+=4;
					is2inA=-1;
				}
				if(is2inA<0) Achar="u";
				isLAT=0;
			}
			else Achar="";
			if(isMozilla){
			chH=(*Achar=='u')?18:16;
			chW=16;
			if(isH1){
				chH<<=1;
				chW<<=1;
			}
			}
				
			
			if( do256 ){
			 if(cs256!=-1){
                          t256c=(isKOI)? koi8tocyr(sp[0]) : sp[0];
			  if(isMozilla)
			  sprintf(dp,"<IMG SRC=\"%s%s/%s%s%02x%02x\" WIDTH=%d HEIGHT=%d>",ubase,charset,Hchar,Achar,cs256,t256c,chW>>1,chH);
			  else
                          sprintf(dp,"<IMG SRC=\"%s%s/%s%s%02x%02x\">",ubase,charset,Hchar,Achar,cs256,t256c);
		       	  dp += strlen(dp);
			 }
			 sp++;
			}
			else {
			if(sp[1] & 0x80){
				if(isMozilla)
				sprintf(dp,"<IMG SRC=\"%s%s/%s%s%x%x\" WIDTH=%d HEIGHT=%d>",ubase,charset,Hchar,Achar,sp[0],sp[1],chW,chH);
				else
                                sprintf(dp,"<IMG SRC=\"%s%s/%s%s%x%x\">",ubase,charset,Hchar,Achar,sp[0],sp[1]);
				dp += strlen(dp); sp += 2;
			}else	sp++;
			}
		}else{	if(isPlain){ switch(*sp) {
				case '<' : 
					sprintf(dp,"&lt;");
					dp += 4; sp++;
					break;
				case '>' : 
					sprintf(dp,"&gt;");
					dp += 4; sp++;
					break;
				case '&' : 
					sprintf(dp,"&amp;");
					dp += 5; sp++;
					break;
				case '"' : 
					sprintf(dp,"&quot;");
					dp += 6; sp++;
					break;
				default:
					*dp++ = *sp++;
					break;
				    }
			}else {
				if(isAnchor){
					if(isIMG){
					if(*sp==' '){
						if(is2inA>0){
	                                        sprintf(dp,"</A>");
        	                                dp+=4;
						is2inA=-1;
						}
						if(!isH1){
						if(isMozilla)
						sprintf(dp,"<IMG SRC=\"%suSPACE\" WIDTH=8 HEIGHT=18>",ubase);
						else
                                                sprintf(dp,"<IMG SRC=\"%suSPACE\">",ubase);
						}
						else{
						if(isMozilla)
                                                sprintf(dp,"<IMG SRC=\"%shuSPACE\" WIDTH=16 HEIGHT=36>",ubase);
						else
                                                sprintf(dp,"<IMG SRC=\"%shuSPACE\">",ubase);
						}
						
                                                dp+=strlen(dp); sp++;

					}
					else{
						isLAT=1;
						isIMG=0;
						if(is2inA<0){
						strcpy(dp,AncBuf);
						dp+=strlen(dp);
						is2inA=0;
						}
						*dp++ = *sp++;
					}
					} else {*dp++ = *sp++; isLAT=1;}
				}
				else *dp++ = *sp++;
			 }
		}
	}
	}
	*dp = 0;
	if(TagBufLen)
	TagBufLen=0;
	
	return dst;
}

#define ESC 	'\033'
#define TO1B 	','
#define TO2B	'$'
#define TOASC1	'('
#define TOASC2	'B'
#define TOJAP	'B'
#define TOCHI	'A'
#define TOCYR 	'L'
#define TOGRE 	'F'
#define TOHEB 	'H'
#define R2L1 	'['
#define R2L3	']'
#define R2LIN	'2'
#define R2LOUT 	'0'

ISO2022_toCII(src,dst,ctype,charsets,ubase)
unsigned char *src, *dst;
char *ctype,*charsets[],*ubase;
{
unsigned char *tmpbuf,*tmpdst;
register unsigned char  *sp, *dp;
char *Charsets[]={"jp","cyr","gre","heb",0};
int csn=0,csnprev,isR2L=0;

tmpdst=dst;
*tmpdst='\0';
tmpbuf = (unsigned char *)malloc(strlen(src)+1);
for(sp=src,dp=tmpbuf; *sp;){
	if(*sp==ESC){
		csnprev=csn;
		if(sp[1]==TO1B){
			switch(sp[2]){
			case TOCYR:
				csn=1;
				break;
			case TOGRE:
				csn=2;
				break;
			case TOHEB:
				csn=3;
				break;
			default:
				csn=0;
			}
			if(csn){
			sp+=3;
			if(csn!=csnprev){
			*dp='\0';
			if(isR2L)rvrsBUF(tmpbuf);
        		EUC_TO_CII(tmpbuf,tmpdst,ctype,Charsets[csnprev],ubase);
        		tmpdst+=strlen(tmpdst);
			dp=tmpbuf;
			}
			}else sp++;
		}
		else
		if(sp[1]==TOASC1 && sp[2]==TOASC2){
			sp+=3;
			if(csn){
			*dp='\0';
			if(isR2L)rvrsBUF(tmpbuf);
        		EUC_TO_CII(tmpbuf,tmpdst,ctype,Charsets[csn],ubase);
       			tmpdst+=strlen(tmpdst);
			dp=tmpbuf;
			csn=0;
			}
		}
		else
		if(sp[1]==R2L1 && sp[3]==R2L3){
			if(sp[2]==R2LIN){
				sp+=4;
				if(!isR2L){
				isR2L=1;	
	                        *dp='\0';
	                        EUC_TO_CII(tmpbuf,tmpdst,ctype,Charsets[csn],ubase);
	                        tmpdst+=strlen(tmpdst);
	                        dp=tmpbuf;
				}
			}else
			if(sp[2]==R2LOUT){
				sp+=4;
				if(isR2L){
                		*dp='\0';
	                        if(isR2L)rvrsBUF(tmpbuf);
                                EUC_TO_CII(tmpbuf,tmpdst,ctype,Charsets[csn],ubase);
                                tmpdst+=strlen(tmpdst);
                                dp=tmpbuf;
				isR2L=0;
				}
			}else sp++;

		}
		else sp++;

	}else{
		*dp=(csn && *sp>0x20 && *sp<=0x7f)? *sp|0x80 : *sp;
		dp++;
		*dp='\0';
		sp++;
	}
}

EUC_TO_CII(tmpbuf,tmpdst,ctype,Charsets[csn],ubase);
free(tmpbuf);
}        

CII_toCII(any,gr,ctype,charsets,ubase)
	unsigned char *any,*gr;
	char *ctype,*charsets[];
	char *ubase;
{	unsigned char *euc;
	int i, strC;
	char *charsetsII;

	strC=isN256C(any);
	charsetsII=(inHTMLcs)? inHTMLcs  : charsets[0];
	if(!strncmp(charsetsII,"koi8",4)) isKOI=1;
	else isKOI=0; 	
        if( (strC>=0 && isKOI) || (!strC && to256c(charsetsII))) 
	EUC_TO_CII(any,gr,ctype,charsets[0],ubase);
	else{
	euc = (unsigned char*)malloc(strlen(any)+1);
	TO_EUC(any,euc);
	if(strC<0 && strchr(euc,0x1b))
	ISO2022_toCII(euc,gr,ctype,charsets,ubase);
	else
	EUC_TO_CII(euc,gr,ctype,charsets[0],ubase);
	free(euc);
	}
}

extern char *xbmsrc[];
extern int xbmind[];
static char *getCII_JIS(name,xbmbuf)
	char *name,*xbmbuf;
{	int i,euc,kanind,isU;
	char *gkand,*curxbm;
	gkand = xbmbuf;
	isU=(*name=='u')? 1: 0;
	sscanf((isU)?name+1 : name,"%x",&euc);
	if(euc<0xa1a1) return 0;
	kanind=(euc/256-161)*94 + euc%256-161;
	if(xbmind[kanind] == -1) return 0;
	curxbm = xbmsrc[xbmind[kanind]];
	sprintf(gkand,"#define %s_width 16\n#define %s_height %d\nstatic char %s_bits[] = {\n\0",name,name,(isU)? 18: 16,name);
	for(i = 0; i< 32; i++) {
	sprintf(gkand+strlen(gkand),"0x%02x,\0",(unsigned char)curxbm[i]);
	}
	if(isU) sprintf(gkand+strlen(gkand),"0x00,0x00,0xff,0xff,\0");
	sprintf(gkand+strlen(gkand)-1,"};\n\0");
	return gkand;
}

static char *getCII_256(name,xbmbuf)
        char *name,*xbmbuf;
{       int i,code,cindr,cindc,isU;
        char *gchd,*curxbm;
        gchd = xbmbuf;
        isU=(*name=='u')? 1: 0;
        sscanf((isU)?name+1 : name,"%x",&code);
        cindr=code/256; cindc=code%256; 
	if(cindr>numof256c || xbmind_256[cindr][cindc] == -1) return 0;
        curxbm = xbmsrc_256[cindr][xbmind_256[cindr][cindc]];
        sprintf(gchd,"#define %s_width 8\n#define %s_height %d\nstatic char %s_bits[] = {\n\0",name,name,(isU)? 18: 16,name);
        for(i = 0; i< 16; i++) {
        sprintf(gchd+strlen(gchd),"0x%02x,\0",(unsigned char)curxbm[i]);
        }
        if(isU) sprintf(gchd+strlen(gchd),"0x00,0xff,\0");
        sprintf(gchd+strlen(gchd)-1,"};\n\0");
        return gchd;
}



static char *getCII_JIS_H1(name,xbmbuf)
        char *name,*xbmbuf;
{       int i,euc,kanind,isU,dxbm1,dxbm2;
        char *gkand,*curxbm;
        gkand = xbmbuf;
        isU=(*name=='u')? 1: 0;
        sscanf((isU)?name+1 : name,"%x",&euc);
	if(euc<0xa1a1) return 0;
        kanind=(euc/256-161)*94 + euc%256-161;
        if(xbmind[kanind] == -1) return 0;
        curxbm = xbmsrc[xbmind[kanind]];
        sprintf(gkand,"#define h%s_width 32\n#define h%s_height %d\nstatic char h%s_bits[] = {\n\0",name,name,(isU)? 36: 32,name);
        for(i = 0; i< 32; i+=2) {
	dxbm1=expandH1((unsigned char)curxbm[i]);
        dxbm2=expandH1((unsigned char)curxbm[i+1]);
        sprintf(gkand+strlen(gkand),"0x%02x,0x%02x,\0",dxbm1%256,dxbm1/256);
        sprintf(gkand+strlen(gkand),"0x%02x,0x%02x,\0",dxbm2%256,dxbm2/256);
        sprintf(gkand+strlen(gkand),"0x%02x,0x%02x,\0",dxbm1%256,dxbm1/256);
        sprintf(gkand+strlen(gkand),"0x%02x,0x%02x,\0",dxbm2%256,dxbm2/256);
        }
        if(isU) sprintf(gkand+strlen(gkand),"0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,\0");
        sprintf(gkand+strlen(gkand)-1,"};\n\0");
        return gkand;
}

static char *getCII_256_H1(name,xbmbuf)
        char *name,*xbmbuf;
{       int i,code,cindr,cindc,isU,dxbm;
        char *gchd,*curxbm;
        gchd = xbmbuf;
        isU=(*name=='u')? 1: 0;
        sscanf((isU)?name+1 : name,"%x",&code);
        cindr=code/256; cindc=code%256;
        if(cindr>numof256c || xbmind_256[cindr][cindc] == -1) return 0;
        curxbm = xbmsrc_256[cindr][xbmind_256[cindr][cindc]];
        sprintf(gchd,"#define h%s_width 16\n#define h%s_height %d\nstatic char h%s_bits[] = {\n\0",name,name,(isU)? 36: 32,name);
        for(i = 0; i< 16; i++) {
        dxbm=expandH1((unsigned char)curxbm[i]);
        sprintf(gchd+strlen(gchd),"0x%02x,0x%02x,\0",dxbm%256,dxbm/256);
        sprintf(gchd+strlen(gchd),"0x%02x,0x%02x,\0",dxbm%256,dxbm/256);
        }
        if(isU) sprintf(gchd+strlen(gchd),"0x00,0x00,0x00,0x00,0xff,0xff,0xff,0xff,\0");
        sprintf(gchd+strlen(gchd)-1,"};\n\0");
        return gchd;
}





char *CII_getXBM(name,xbmbuf)
	char *name, *xbmbuf;
{	char charset[32],code[32];
	char *getCII_JIS(),*getCII_256(),*gchd;
	int i;

	sscanf(name,"%[^/]/%s",charset,code);
	if(!strncmp(name,"uSPACE",6)){
	gchd=xbmbuf;
        sprintf(gchd,"#define uSPACE_width 8\n#define uSPACE_height 18\nstatic char uSPACE_bits[] = {\n\0");
        for(i = 0; i< 17; i++) {
        sprintf(gchd+strlen(gchd),"0x00,\0");
        }
        sprintf(gchd+strlen(gchd),"0xff};\n\0");
	return gchd;
	}
        if(!strncmp(name,"huSPACE",7)){
        gchd=xbmbuf;
        sprintf(gchd,"#define huSPACE_width 16\n#define huSPACE_height 36\nstatic char uSPACE_bits[] = {\n\0");
        for(i = 0; i< 68; i++) {
        sprintf(gchd+strlen(gchd),"0x00,\0");
        }
        sprintf(gchd+strlen(gchd),"0xff,0xff,0xff,0xff};\n\0");
        return gchd;
        }

	if(*code=='h'){
        if( to256c(charset) )
                return getCII_256_H1(code+1,xbmbuf);
        else    return getCII_JIS_H1(code+1,xbmbuf);

	} else {
	if( to256c(charset) )
		return getCII_256(code,xbmbuf);
	else	return getCII_JIS(code,xbmbuf);
	}
}

CII_putHTTP(tc,vno,gkan)
	FILE *tc;
	char *gkan;
{	char *data;
	int size;
	int leng = 0;
	char xbmbuf[2000];

	if( (data = CII_getXBM(gkan,xbmbuf)) == 0 )
		return 0;

	size = strlen(data);
	leng += HTTP_putHeader(tc,vno,"image/x-xbitmap",size);
	leng += fwrite(data,1,size,tc);
	return leng;
}

